// btm2tad version 0.100
//  BTMemoΥե뷲TADľС 
// (C)Copyright 2003, Yashiro Takeshi

// Btm2TAD.h : ץꥱΥᥤ󥯥饹

#ifndef _DEFINE_H_BTM2TAD
#define _DEFINE_H_BTM2TAD

#include <map>
#include <string>
#include <basic.h>
#include <btron/vobj.h>
#include <btron/hmi.h>
#include <tstring.h>

#include "Win32Types.h"

class Btm2TAD {
  std::map<std::string, LINK> fileLink;
  LINK* dest;
  LINK* src;
  TRAYREC tray;
  TR_VOBJREC tray_cnt;
public:
  Btm2TAD(LINK *link);
  ~Btm2TAD();
  int run();
  LINK* parseBtmFile(LINK *link);
  int parseBtmData(W outFD, LINK* cur, UB *buf, int size);
  static COLOR transformColor(Windows32::COLORREF col);
  void copyTADSegment(W srcFD, W destFD);
  static void trimPathAndExt(TC *tcs);
  static void copyLinkAttr(const LINK* src, LINK* dest);
};

#endif // _DEFINE_H_BTM2TAD
