// btm2tad version 0.100
//  BTMemoΥե뷲TADľС 
// (C)Copyright 2003, Yashiro Takeshi

// BtmSegment.h : BTMemo

#ifndef _DEFINE_H_BTMSEGMENT
#define _DEFINE_H_BTMSEGMENT

#include "Win32Types.h"
#include "AbstractSegment.h"
#include "TADSegment.h"

#pragma pack(1)

class BtmSegment : public AbstractSegment<int> {
public:
  TADSegment* createTADSegment(int i);
  bool isLinkSegment(){
    if (id == 0xffe6){
      return true;
    }
    return false;
  }
};

// ========== ʲϻ¿ʥȤ ==========

// ĹȤASCII/Shift_JIS
// 0x00(̵)BTMemo ver 1.05ʲǥѥǥ󥰤ƤΤ

////////////////////////////////////////////////////

#define _MAX_PATH 260

// °
// ̤16ӥåȤ϶°֥ȤѤ
#define BTATTR_BORDER  0x00000001  // ɽ

// ̤16ӥåȤϳƥ֥ȤȤ˸ͭ˻Ѥ

// (1) ƥBOX֥
//#define BTATTR_MULTILINE 0x80000000  // ʣԤ
#define BTATTR_AUTONL  0x40000000  // ɥǤμư
//#define BTATTR_BROWS  0x20000000  // ֥饦⡼

// (2) ӥåȥޥåץ֥
#define BTATTR_STRETCH  0x80000000  // ȥåɽ

// (3) 󥯥֥
//#define BTATTR_FILESTRETCH 0x02000000  // ȥåɽʲեΤߡ
#define BTATTR_NOCAPTION  0x04000000  // ĥҤɽʤV1.04̤ѡ
#define BTATTR_USEDOCNAME 0x04000000  // ʸ̾ɽ롣BTATTR_USEFNAMEͭˤΤͭ(V1.05ʹ)
#define BTATTR_NOEXT    0x08000000  // ĥҤɽʤ
#define BTATTR_NOPATH   0x10000000  // ѥɽʤ
#define BTATTR_USEFNAME 0x20000000  // ե̾ɽ
#define BTATTR_DRAWICON 0x40000000  // ɽ
#define BTATTR_OPEN     0x80000000  // ȤƤ

// ----------------------------------------------
// 0xA0 : Ǿ󥻥
// ----------------------------------------------
class BtmPageSegment : public BtmSegment {
public:
  short sOrientation; // ѻθ
  short sPaperSize;   // ѻΥֹ
  short sPaperLength; // ѻĹ(ñ̤0.1mm)
  short sPaperWidth;  // ѻ
  int top;            // С쥤ޡ(ŷ)(ñ̤0.01mm)
  int bottom;         // С쥤ޡ()
  int left;           // С쥤ޡ(Υ)
  int right;          // С쥤ޡ()
};

// ----------------------------------------------
// 0xA2 : եȥ
// ----------------------------------------------
class BtmFontSegment : public BtmSegment {
public:
  Windows32::LOGFONT font;
};

// ----------------------------------------------
// 0xA6 : ʸ
// ----------------------------------------------
class BtmTextColorSegment : public BtmSegment {
public:
  Windows32::COLORREF col;
};

// ----------------------------------------------
// 0xE0 : 󥻥
// ----------------------------------------------
class BtmSegmentInfoSegment : public BtmSegment {
public:
  unsigned int ver; // ե빽¤С
                    // BTMemo Ver1.001.03 : 0x0000
                    //        Ver1.04     : 0x0100
  Windows32::WINDOWPLACEMENT placement; // ɥΰ֡
  Windows32::SIZE sizScroll; // ʸɽ(̡pixelñ)
  char fname[1];             // ¿̾BTMemo V1.05ʹߤǻѡ
};

// ----------------------------------------------
// 0xE1 : ʸ񳫻ϥ
// ----------------------------------------------
class BtmTextSegment : public BtmSegment {
public:
  unsigned int attr;           // ʸϥȤ°
  Windows32::COLORREF colBack; // ɥطʿ
  Windows32::POINT ptObject;   // ֥(Ver1.04ɲ)
  Windows32::SIZE sizObject;   // ʸǡɽʥԥñ̡
};

// ----------------------------------------------
// 0xE2 : ʸλ
// ----------------------------------------------
class BtmTextEndSegment : public BtmSegment {
  ; // BtmTextEndSegment has no field.
};

// ----------------------------------------------
// 0xE5 : 
// ----------------------------------------------
class BtmBitmapSegment : public BtmSegment {
public:
  unsigned int attr;         // Ȥ°
  Windows32::POINT ptObject; // (Ver1.04ɲ)
  Windows32::SIZE siz;       // 襵(ޡޤ)
  Windows32::BITMAPINFO bmi; // ӥåȥޥå׾(ѥ)
};

// ----------------------------------------------
// 0xE6 : 󥯥
// ----------------------------------------------
class BtmLinkSegment : public BtmSegment {
public:
  unsigned int attr;           // 󥯥Ȥ°
  Windows32::COLORREF colBack; // Ȥطʿ
  Windows32::POINT ptObject;   // (Ver1.04ɲ)
  Windows32::SIZE sizObject;   // 襵(ޡޤ)
  Windows32::SIZE sizScroll;   // Ȥɽְ־(pixelñ)
  struct BtmLink {
    unsigned short kind; // Υեμ
                         // (0:BTMemo / 1:¾)
    int fid; // եֹ
             // (ե̤֥ĥեξˤΤ߻ѡ
             //  BTMemoǤϻѤƤʤ)
    char szPath[_MAX_PATH]; // ۥȤǤΥե륷ƥ̾
             // WindowsǤϥե֤Ƥǥ쥯ȥѥ
             // 󥯤ξϥեΥѥ̾
             // BTMemoǤϡ󥯥եΥեѥ̾Ȥƻ
    char szHost[_MAX_PATH]; // եΥۥ̾
                            // (BTMemoǤϻѤƤʤ)
  } link_body;
  int nCaption; // ФʸΥХȿʽüʸޤޤʤ
  char dt[2];   // ФγǼΰnCaptionΥХȿʬ
};

// 0xE3 : ޷ϥ(ͽ)
// 0xE4 : ޷λ(ͽ)

// * ɲäɬ createTADSegment() 뤳

#pragma pack()

#endif // _DEFINE_H_BTMSEGMENT
