// btm2tad version 0.100
// ` BTMemõt@CQTADɒRo[^ `
// (C)Copyright 2003, Yashiro Takeshi

// wintypes.h : WindowsŗL̃f[^^`

#ifndef _DEFINE_H_WINTYPES
#define _DEFINE_H_WINTYPES

namespace Windows32 {
  
  typedef unsigned long COLORREF;
  
  typedef struct tagRECT {
    long left;
    long top;
    long right;
    long bottom;
  } RECT;
  
  typedef struct tagPOINT {
    long x;
    long y;
  } POINT;
  
  typedef struct tagSIZE {
    long cx;
    long cy;
  } SIZE;
  
  typedef struct tagLOGFONT {
    long lfHeight;
    long lfWidth;
    long lfEscapement;
    long lfOrientation;
    long lfWeight;
    unsigned char lfItalic;
    unsigned char lfUnderline;
    unsigned char lfStrikeOut;
    unsigned char lfCharSet;
    unsigned char lfOutPrecision;
    unsigned char lfClipPrecision;
    unsigned char lfQuality;
    unsigned char lfPitchAndFamily;
    char lfFaceName[1]; // UnicodeȂwchar^
  } LOGFONT;
  
  typedef struct tagWINDOWPLACEMENT {
    unsigned int  length;
    unsigned int  flags;
    unsigned int  showCmd;
    POINT ptMinPosition;
    POINT ptMaxPosition;
    RECT  rcNormalPosition;
  } WINDOWPLACEMENT;
  
  typedef struct tagBITMAPINFOHEADER{
    unsigned long  biSize;
    long   biWidth;
    long   biHeight;
    unsigned short   biPlanes;
    unsigned short   biBitCount;
    unsigned long  biCompression;
    unsigned long  biSizeImage;
    long   biXPelsPerMeter;
    long   biYPelsPerMeter;
    unsigned long  biClrUsed;
    unsigned long  biClrImportant;
  } BITMAPINFOHEADER;
  
  typedef struct tagRGBQUAD {
    unsigned char    rgbBlue;
    unsigned char    rgbGreen;
    unsigned char    rgbRed;
    unsigned char    rgbReserved;
  } RGBQUAD;
  
  
  typedef struct tagBITMAPINFO {
    BITMAPINFOHEADER    bmiHeader;
    RGBQUAD             bmiColors[1];
  } BITMAPINFO;
  
};

#endif // _DEFINE_H_WINTYPES
